GNU bug report logs - #30265
Fish embeds store file names in UCS-4/UTF-32 literal strings

Please note: This is a static page, with minimal formatting, updated once a day.
Click here to see this page with the latest information and nicer formatting.

Package: guix; Severity: important; Reported by: Meiyo Peng <meiyo.peng@HIDDEN>; dated Sat, 27 Jan 2018 09:13:01 UTC; Maintainer for guix is bug-guix@HIDDEN.
Severity set to 'important' from 'normal' Request was from Ludovic Courtès <ludo@HIDDEN> to control <at> debbugs.gnu.org. Full text available.
Changed bug title to 'Fish embeds store file names in UCS-4/UTF-32 literal strings' from 'Fish shell has wrong path variables' Request was from Ludovic Courtès <ludo@HIDDEN> to control <at> debbugs.gnu.org. Full text available.

Message received at 30265 <at> debbugs.gnu.org:


Received: (at 30265) by debbugs.gnu.org; 21 Sep 2018 15:11:54 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Fri Sep 21 11:11:54 2018
Received: from localhost ([127.0.0.1]:48347 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1g3N62-0002tQ-64
	for submit <at> debbugs.gnu.org; Fri, 21 Sep 2018 11:11:54 -0400
Received: from relay8-d.mail.gandi.net ([217.70.183.201]:48395)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <mail@HIDDEN>) id 1g3N5z-0002tD-F5
 for 30265 <at> debbugs.gnu.org; Fri, 21 Sep 2018 11:11:53 -0400
X-Originating-IP: 88.190.253.40
Received: from mimimi (unknown [88.190.253.40])
 (Authenticated sender: mail@HIDDEN)
 by relay8-d.mail.gandi.net (Postfix) with ESMTPSA id 407EE1BF206;
 Fri, 21 Sep 2018 15:11:48 +0000 (UTC)
References: <87pnx9yhsx.fsf@HIDDEN> <87o9ctdxxk.fsf@HIDDEN>
 <87efdoxia5.fsf@HIDDEN> <877ejf2gyp.fsf@HIDDEN>
 <877ejeykro.fsf@HIDDEN> <87y3buucw2.fsf@HIDDEN>
User-agent: mu4e 1.0; emacs 26.1
From: Pierre Neidhardt <mail@HIDDEN>
To: Ricardo Wurmus <rekado@HIDDEN>
Subject: Re: bug#30265: Fish shell has wrong path variables
In-reply-to: <87y3buucw2.fsf@HIDDEN>
Date: Fri, 21 Sep 2018 17:11:48 +0200
Message-ID: <875zyyyjez.fsf@HIDDEN>
MIME-Version: 1.0
Content-Type: multipart/signed; boundary="=-=-=";
 micalg=pgp-sha256; protocol="application/pgp-signature"
X-Spam-Score: -0.7 (/)
X-Debbugs-Envelope-To: 30265
Cc: Ludovic =?utf-8?Q?Court=C3=A8s?= <ludo@HIDDEN>, meiyo.peng@HIDDEN,
 30265 <at> debbugs.gnu.org, Nils Gillmann <ng0@HIDDEN>
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.7 (-)

--=-=-=
Content-Type: text/plain
Content-Transfer-Encoding: quoted-printable

Makes sense, that explains it.  Thanks!

=2D-=20
Pierre Neidhardt
https://ambrevar.xyz/

--=-=-=
Content-Type: application/pgp-signature; name="signature.asc"

-----BEGIN PGP SIGNATURE-----

iQEzBAEBCAAdFiEEUPM+LlsMPZAEJKvom9z0l6S7zH8FAlulCjQACgkQm9z0l6S7
zH9yVwf/fnG+29yRw8/4Qq24ZxP/aBKBUImj+0xZBDNZY0zGOnIQ+08zxvEjEq5v
LVfdZmIdGPkvBwpSrXcoO2bBTmFucbtbSIiCQrwfeU/oMfGGEFqrptWC6V1BJU2r
4fZVjqhrebciyYg/YHWw+HCouQBiNwnVg2iDLTT/fOny4R7dyLNJOMLhzWNNxw5S
10V0rnJgQ8GZWn5kxccIZ1ypjavt/dDd1NMOELGc+d9W9Y/TJaJDTAIgi1YkKscl
zQyYZADTRwGc2sXwJH+vj1q2cHwFOPs14e1sr4rfi8YiNu3zKrf3g96mE901z+by
6v1GXgHQNEjtYoeDoIfy0PXBmI7SZA==
=ROaI
-----END PGP SIGNATURE-----
--=-=-=--




Information forwarded to bug-guix@HIDDEN:
bug#30265; Package guix. Full text available.

Message received at 30265 <at> debbugs.gnu.org:


Received: (at 30265) by debbugs.gnu.org; 21 Sep 2018 14:46:55 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Fri Sep 21 10:46:55 2018
Received: from localhost ([127.0.0.1]:48314 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1g3Mhq-0002Az-UO
	for submit <at> debbugs.gnu.org; Fri, 21 Sep 2018 10:46:55 -0400
Received: from sender-of-o51.zoho.com ([135.84.80.216]:21106)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <rekado@HIDDEN>) id 1g3Mho-0002Aq-Vr
 for 30265 <at> debbugs.gnu.org; Fri, 21 Sep 2018 10:46:53 -0400
ARC-Seal: i=1; a=rsa-sha256; t=1537541187; cv=none; d=zoho.com; s=zohoarc; 
 b=hufmG0BhkHiqMKUVk7PJEZf2ppGGHbdTjF6IFJEUzf2y2nXVRloVTyAesU+dAY8QnKeE74OWXsfHdUGRZcDtCc1BQwj55tJ+os9tUTevIP+jyatSTTge5Lk2E/lf11PLZoSZcG9+/R21L6JqRpuI9AnRt+GzfYCts+m3naa9/NE=
ARC-Message-Signature: i=1; a=rsa-sha256; c=relaxed/relaxed; d=zoho.com;
 s=zohoarc; t=1537541187;
 h=Content-Type:Content-Transfer-Encoding:Cc:Date:From:In-Reply-To:MIME-Version:Message-ID:References:Subject:To:ARC-Authentication-Results;
 bh=D8RuWsbOWAZx0E+gvuUGIt77JJC9rd7rf+MP+mzIw+M=; 
 b=Ab3AbWRejzZ5iUJZTAsm4rYRjLr84kyoerL4H+gAXcl3HiFUMjvP/3B/ifxk9mZfkWv6Ccjllyr0VgnynPwFkrJ8oex+nclQm/mDLis/5HJU6Yz74mE6PvvFj2DJtfKn4LP3WuIw0Un5Bire3a4JiVmSJ/TxVsHxemIHJgD4rNo=
ARC-Authentication-Results: i=1; mx.zoho.com; dkim=pass  header.i=elephly.net;
 spf=pass  smtp.mailfrom=rekado@HIDDEN;
 dmarc=pass header.from=<rekado@HIDDEN> header.from=<rekado@HIDDEN>
DKIM-Signature: v=1; a=rsa-sha256; q=dns/txt; c=relaxed/relaxed; t=1537541187; 
 s=zoho; d=elephly.net; i=rekado@HIDDEN;
 h=References:From:To:Cc:Subject:In-reply-to:Date:Message-ID:MIME-Version:Content-Type:Content-Transfer-Encoding;
 l=1254; bh=D8RuWsbOWAZx0E+gvuUGIt77JJC9rd7rf+MP+mzIw+M=;
 b=VZoGbcEScq6Nci2zUmjQ2RfoHp8RzgI/wNu68Ra4Zb9/RnHUZrNdEWZnbGPJle6N
 8ZHBiL4X8XwVkYhTnzcsx97f6gZxV4C0JJsu09HGSvi92IX3ibhz+CMj9Jphx+y1OXV
 BQIGXdzE/cyzlT4ZFVuONXHMdG7V9bX6jynYsY8c=
Received: from localhost (141.80.247.147 [141.80.247.147]) by mx.zohomail.com
 with SMTPS id 1537541186381385.00429850868875;
 Fri, 21 Sep 2018 07:46:26 -0700 (PDT)
References: <87pnx9yhsx.fsf@HIDDEN> <87o9ctdxxk.fsf@HIDDEN>
 <87efdoxia5.fsf@HIDDEN> <877ejf2gyp.fsf@HIDDEN>
 <877ejeykro.fsf@HIDDEN>
User-agent: mu4e 1.0; emacs 26.1
From: Ricardo Wurmus <rekado@HIDDEN>
To: Pierre Neidhardt <mail@HIDDEN>
Subject: Re: bug#30265: Fish shell has wrong path variables
In-reply-to: <877ejeykro.fsf@HIDDEN>
X-URL: https://elephly.net
X-PGP-Key: https://elephly.net/rekado.pubkey
X-PGP-Fingerprint: BCA6 89B6 3655 3801 C3C6  2150 197A 5888 235F ACAC
Date: Fri, 21 Sep 2018 16:46:21 +0200
Message-ID: <87y3buucw2.fsf@HIDDEN>
MIME-Version: 1.0
Content-Type: text/plain; charset=utf-8
Content-Transfer-Encoding: quoted-printable
X-ZohoMailClient: External
X-Spam-Score: 0.0 (/)
X-Debbugs-Envelope-To: 30265
Cc: Ludovic =?utf-8?Q?Court=C3=A8s?= <ludo@HIDDEN>, meiyo.peng@HIDDEN,
 30265 <at> debbugs.gnu.org, Nils Gillmann <ng0@HIDDEN>
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)


Pierre Neidhardt <mail@HIDDEN> writes:

>> In practice only a subset of these grafts are applied because, for
>> instance, Fish doesn=E2=80=99t depend (directly or indirectly) on Ghosts=
cript at
>> run time whereas it does depend on Perl:
>>
>> --8<---------------cut here---------------start------------->8---
>> $ guix gc -R $(guix build fish) | grep -E '(perl|ghostscript)'
>> /gnu/store/7ifc22sh86zblnzamqimgmv06idyx69v-perl-5.26.1
>> --8<---------------cut here---------------end--------------->8---
>
> Thanks for pointing out this nuance, I wasn't aware of it.
>
> But I still wonder: why is fish first built to
> vgrav12zra9zky21ahm4x1qg8g4v58fj... and then immediately grafted to
> avk637800w1n7z1z0hnzx80r0fpd6729... Why not building directly to
> avk637800w1n7z1z0hnzx80r0fpd6729...?

Grafting is independent of building a package.  These are separate
derivations.  The first derivation is merely about building the package
=E2=80=94 it is unaware of the need for grafting.

The second derivation only performs the graft.  All it knows about is
that it takes =E2=80=9Cvgrav12zra9zky21ahm4x1qg8g4v58fj=E2=80=9D as an inpu=
t and should
produce =E2=80=9Cavk637800w1n7z1z0hnzx80r0fpd6729=E2=80=9D.

--
Ricardo





Information forwarded to bug-guix@HIDDEN:
bug#30265; Package guix. Full text available.

Message received at 30265 <at> debbugs.gnu.org:


Received: (at 30265) by debbugs.gnu.org; 21 Sep 2018 14:42:39 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Fri Sep 21 10:42:39 2018
Received: from localhost ([127.0.0.1]:48310 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1g3Mdj-00023Z-DD
	for submit <at> debbugs.gnu.org; Fri, 21 Sep 2018 10:42:39 -0400
Received: from relay3-d.mail.gandi.net ([217.70.183.195]:46651)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <mail@HIDDEN>) id 1g3Mdi-00023R-82
 for 30265 <at> debbugs.gnu.org; Fri, 21 Sep 2018 10:42:38 -0400
X-Originating-IP: 88.190.253.40
Received: from mimimi (unknown [88.190.253.40])
 (Authenticated sender: mail@HIDDEN)
 by relay3-d.mail.gandi.net (Postfix) with ESMTPSA id 4D9C360010;
 Fri, 21 Sep 2018 14:42:36 +0000 (UTC)
References: <87pnx9yhsx.fsf@HIDDEN> <87o9ctdxxk.fsf@HIDDEN>
 <87efdoxia5.fsf@HIDDEN> <877ejf2gyp.fsf@HIDDEN>
User-agent: mu4e 1.0; emacs 26.1
From: Pierre Neidhardt <mail@HIDDEN>
To: Ludovic =?utf-8?Q?Court=C3=A8s?= <ludo@HIDDEN>
Subject: Re: bug#30265: Fish shell has wrong path variables
In-reply-to: <877ejf2gyp.fsf@HIDDEN>
Date: Fri, 21 Sep 2018 16:42:35 +0200
Message-ID: <877ejeykro.fsf@HIDDEN>
MIME-Version: 1.0
Content-Type: multipart/signed; boundary="=-=-=";
 micalg=pgp-sha256; protocol="application/pgp-signature"
X-Spam-Score: -0.7 (/)
X-Debbugs-Envelope-To: 30265
Cc: rekado@HIDDEN, meiyo.peng@HIDDEN, 30265 <at> debbugs.gnu.org,
 Nils Gillmann <ng0@HIDDEN>
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.7 (-)

--=-=-=
Content-Type: text/plain; charset=utf-8
Content-Transfer-Encoding: quoted-printable

> In practice only a subset of these grafts are applied because, for
> instance, Fish doesn=E2=80=99t depend (directly or indirectly) on Ghostsc=
ript at
> run time whereas it does depend on Perl:
>=20
> --8<---------------cut here---------------start------------->8---
> $ guix gc -R $(guix build fish) | grep -E '(perl|ghostscript)'
> /gnu/store/7ifc22sh86zblnzamqimgmv06idyx69v-perl-5.26.1
> --8<---------------cut here---------------end--------------->8---

Thanks for pointing out this nuance, I wasn't aware of it.

But I still wonder: why is fish first built to
vgrav12zra9zky21ahm4x1qg8g4v58fj... and then immediately grafted to
avk637800w1n7z1z0hnzx80r0fpd6729... Why not building directly to
avk637800w1n7z1z0hnzx80r0fpd6729...?

I might be misunderstanding the basics of grafting :p

=2D-=20
Pierre Neidhardt
https://ambrevar.xyz/

--=-=-=
Content-Type: application/pgp-signature; name="signature.asc"

-----BEGIN PGP SIGNATURE-----

iQEzBAEBCAAdFiEEUPM+LlsMPZAEJKvom9z0l6S7zH8FAlulA1sACgkQm9z0l6S7
zH9t4Qf/enxSBr53IaoJsKXXqrtI9XQ0KB+CV5BPZLXjgjIAENHo+qzKU+9UUmz9
PJxcrua7DGcphiA89d0j2xY2utRrHQP4crBfRR2uUb+DArRybf/zSLrelIAzCxqO
bY4QzOQ16Mu4LVQZl2FSg6qHd3fuRstMzVRZ29WU3b+sK4ZjrqaeCGyMf/BEbeEl
th2qnJKLBiUvmAkgytVf8O6fkxp1ZIe7TkRnW0gBQYQxtB0TinN4aOT82U3jjiwb
q07KN+qCtGd+ohvdqICoEmuc4Zt4jXCyfi0cv9lYgCeoE7pZ1UePAg9+ztuTm6cU
HL4HCn1Wn0aIUvqRAEM29OR1SHQ3fA==
=tclm
-----END PGP SIGNATURE-----
--=-=-=--




Information forwarded to bug-guix@HIDDEN:
bug#30265; Package guix. Full text available.

Message received at 30265 <at> debbugs.gnu.org:


Received: (at 30265) by debbugs.gnu.org; 21 Sep 2018 12:06:20 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Fri Sep 21 08:06:20 2018
Received: from localhost ([127.0.0.1]:47704 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1g3KCS-0004X2-Fo
	for submit <at> debbugs.gnu.org; Fri, 21 Sep 2018 08:06:20 -0400
Received: from eggs.gnu.org ([208.118.235.92]:60880)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <ludo@HIDDEN>) id 1g3KCR-0004Wr-Gh
 for 30265 <at> debbugs.gnu.org; Fri, 21 Sep 2018 08:06:19 -0400
Received: from Debian-exim by eggs.gnu.org with spam-scanned (Exim 4.71)
 (envelope-from <ludo@HIDDEN>) id 1g3KCL-0005B7-RV
 for 30265 <at> debbugs.gnu.org; Fri, 21 Sep 2018 08:06:14 -0400
X-Spam-Checker-Version: SpamAssassin 3.3.2 (2011-06-06) on eggs.gnu.org
X-Spam-Level: 
X-Spam-Status: No, score=-1.9 required=5.0 tests=BAYES_00 autolearn=disabled
 version=3.3.2
Received: from fencepost.gnu.org ([2001:4830:134:3::e]:33379)
 by eggs.gnu.org with esmtp (Exim 4.71) (envelope-from <ludo@HIDDEN>)
 id 1g3KC0-0004tr-7D; Fri, 21 Sep 2018 08:05:52 -0400
Received: from [193.50.110.247] (port=57448 helo=ribbon)
 by fencepost.gnu.org with esmtpsa (TLS1.2:RSA_AES_256_CBC_SHA1:256)
 (Exim 4.82) (envelope-from <ludo@HIDDEN>)
 id 1g3KBz-0005TH-Q2; Fri, 21 Sep 2018 08:05:52 -0400
From: ludo@HIDDEN (Ludovic =?utf-8?Q?Court=C3=A8s?=)
To: Pierre Neidhardt <mail@HIDDEN>
Subject: Re: bug#30265: Fish shell has wrong path variables
References: <87pnx9yhsx.fsf@HIDDEN> <87o9ctdxxk.fsf@HIDDEN>
 <87efdoxia5.fsf@HIDDEN>
X-URL: http://www.fdn.fr/~lcourtes/
X-Revolutionary-Date: Jour des =?utf-8?Q?R=C3=A9compenses?= de =?utf-8?Q?l?=
 =?utf-8?Q?'Ann=C3=A9e?= 226 de la =?utf-8?Q?R=C3=A9volution?=
X-PGP-Key-ID: 0x090B11993D9AEBB5
X-PGP-Key: http://www.fdn.fr/~lcourtes/ludovic.asc
X-PGP-Fingerprint: 3CE4 6455 8A84 FDC6 9DB4  0CFB 090B 1199 3D9A EBB5
X-OS: x86_64-pc-linux-gnu
Date: Fri, 21 Sep 2018 14:05:50 +0200
In-Reply-To: <87efdoxia5.fsf@HIDDEN> (Pierre Neidhardt's message of
 "Thu, 20 Sep 2018 18:09:22 +0200")
Message-ID: <877ejf2gyp.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/26.1 (gnu/linux)
MIME-Version: 1.0
Content-Type: text/plain; charset=utf-8
Content-Transfer-Encoding: quoted-printable
X-detected-operating-system: by eggs.gnu.org: GNU/Linux 2.2.x-3.x [generic]
X-Received-From: 2001:4830:134:3::e
X-Spam-Score: -5.0 (-----)
X-Debbugs-Envelope-To: 30265
Cc: rekado@HIDDEN, meiyo.peng@HIDDEN, 30265 <at> debbugs.gnu.org,
 Nils Gillmann <ng0@HIDDEN>
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -6.0 (------)

Pierre Neidhardt <mail@HIDDEN> skribis:

> - Is the issue here that grafting does not support wide string literals?
>   Shouldn't we fix the Guix code to support wide strings as well?

I=E2=80=99m not too keen on doing that: the scanner in (guix build grafts) =
would
have to be quite different if it were to catch /gnu/store references
burried in wide strings.  That=E2=80=99d be a real challenge.

The proposed changes (using Fish=E2=80=99 relocatability mechanism or ensur=
ing
that the /gnu/store references are in char[] arrays) would be far
easier.

Let me know if you need clarifications regarding these.

Thanks,
Ludo=E2=80=99.




Information forwarded to bug-guix@HIDDEN:
bug#30265; Package guix. Full text available.

Message received at 30265 <at> debbugs.gnu.org:


Received: (at 30265) by debbugs.gnu.org; 21 Sep 2018 12:06:06 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Fri Sep 21 08:06:06 2018
Received: from localhost ([127.0.0.1]:47700 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1g3KCE-0004WY-5T
	for submit <at> debbugs.gnu.org; Fri, 21 Sep 2018 08:06:06 -0400
Received: from eggs.gnu.org ([208.118.235.92]:60811)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <ludo@HIDDEN>) id 1g3KCC-0004W3-Mz
 for 30265 <at> debbugs.gnu.org; Fri, 21 Sep 2018 08:06:04 -0400
Received: from Debian-exim by eggs.gnu.org with spam-scanned (Exim 4.71)
 (envelope-from <ludo@HIDDEN>) id 1g3KC3-00050X-S6
 for 30265 <at> debbugs.gnu.org; Fri, 21 Sep 2018 08:05:58 -0400
X-Spam-Checker-Version: SpamAssassin 3.3.2 (2011-06-06) on eggs.gnu.org
X-Spam-Level: 
X-Spam-Status: No, score=-1.9 required=5.0 tests=BAYES_00 autolearn=disabled
 version=3.3.2
Received: from fencepost.gnu.org ([2001:4830:134:3::e]:33218)
 by eggs.gnu.org with esmtp (Exim 4.71) (envelope-from <ludo@HIDDEN>)
 id 1g3K9p-0003mt-Jr; Fri, 21 Sep 2018 08:03:37 -0400
Received: from [193.50.110.247] (port=57430 helo=ribbon)
 by fencepost.gnu.org with esmtpsa (TLS1.2:RSA_AES_256_CBC_SHA1:256)
 (Exim 4.82) (envelope-from <ludo@HIDDEN>)
 id 1g3K9p-0005Fh-A7; Fri, 21 Sep 2018 08:03:37 -0400
From: ludo@HIDDEN (Ludovic =?utf-8?Q?Court=C3=A8s?=)
To: Pierre Neidhardt <mail@HIDDEN>
Subject: Re: bug#30265: Fish shell has wrong path variables
References: <87pnx9yhsx.fsf@HIDDEN> <87o9ctdxxk.fsf@HIDDEN>
 <87efdoxia5.fsf@HIDDEN> <877ejgumrn.fsf@HIDDEN>
 <87bm8sxfd4.fsf@HIDDEN>
X-URL: http://www.fdn.fr/~lcourtes/
X-Revolutionary-Date: Jour des =?utf-8?Q?R=C3=A9compenses?= de =?utf-8?Q?l?=
 =?utf-8?Q?'Ann=C3=A9e?= 226 de la =?utf-8?Q?R=C3=A9volution?=
X-PGP-Key-ID: 0x090B11993D9AEBB5
X-PGP-Key: http://www.fdn.fr/~lcourtes/ludovic.asc
X-PGP-Fingerprint: 3CE4 6455 8A84 FDC6 9DB4  0CFB 090B 1199 3D9A EBB5
X-OS: x86_64-pc-linux-gnu
Date: Fri, 21 Sep 2018 14:03:35 +0200
In-Reply-To: <87bm8sxfd4.fsf@HIDDEN> (Pierre Neidhardt's message of
 "Thu, 20 Sep 2018 19:12:23 +0200")
Message-ID: <87d0t72h2g.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/26.1 (gnu/linux)
MIME-Version: 1.0
Content-Type: text/plain; charset=utf-8
Content-Transfer-Encoding: quoted-printable
X-detected-operating-system: by eggs.gnu.org: GNU/Linux 2.2.x-3.x [generic]
X-Received-From: 2001:4830:134:3::e
X-Spam-Score: -5.0 (-----)
X-Debbugs-Envelope-To: 30265
Cc: Ricardo Wurmus <rekado@HIDDEN>, meiyo.peng@HIDDEN,
 30265 <at> debbugs.gnu.org, Nils Gillmann <ng0@HIDDEN>
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -6.0 (------)

Pierre Neidhardt <mail@HIDDEN> skribis:

>> A package will be grafted when any
>> of its inputs (direct or transitive) have been replaced.
>
> I understand why that would happen when _updating_ fish, but why does it =
happen
> when (re-)building it from scratch, for instance when the graft source is=
 gone
> from the store?

Whether a package is grafted depends on its dependencies and the set of
applicable grafts.  For instance, these are the grafts that can
potentially be applied to Fish as of commit
1df40d3dbff82c2990271b406b32633fe216d143:

--8<---------------cut here---------------start------------->8---
scheme@(guile-user)> ,use(guix)
scheme@(guile-user)> ,use(gnu packages shells)
scheme@(guile-user)> (define s (open-connection))
scheme@(guile-user)> (package-grafts s fish)
$8 =3D (#<graft /gnu/store/f4d2v9y191zvj66c4rr65s8bix67wnma-libtiff-4.0.9 =
=3D=3D> /gnu/store/p2531jppdwwgn312bzwmm6q2cbmcdyc5-libtiff-4.0.9 2ff7840> =
#<graft /gnu/store/74iniafz6s76vbshzkq7zvx6nicd91y6-jbig2dec-0.14 =3D=3D> /=
gnu/store/vjailgb48w3jcf7brb2cgf61j9an3blm-jbig2dec-0.15 33b2630> #<graft /=
gnu/store/dysmb6hz7rr5rvcb05p23dazc5hz26qm-libgcrypt-1.8.2 =3D=3D> /gnu/sto=
re/hc5cak3fj0dijbm86kpz2asl7ld4gf8y-libgcrypt-1.8.3 32688d0> #<graft /gnu/s=
tore/r8ppi963s5xlf78lxd74y31263m1fxl2-libx11-1.6.5 =3D=3D> /gnu/store/bid7h=
vpnm8nq04vm4dszywxsw9g2kmf2-libx11-1.6.6 3268630> #<graft /gnu/store/4n6v2z=
p5mslq2784j878dmfzzj4vvmza-openssl-1.0.2o =3D=3D> /gnu/store/x8nacy2qpqlwi0=
gm7r6slcynv1cwmicb-openssl-1.0.2o 305de40> #<graft /gnu/store/jxa597l2zp6yd=
i345djxwabg5gp9h4di-ghostscript-9.23 =3D=3D> /gnu/store/fhbiaq9bnp4m79bd6wd=
fi9px41mwmdib-ghostscript-9.24 294aa80> #<graft /gnu/store/6zz27h4l21b8f2mi=
frk9sidvib9cns2i-perl-5.26.1 =3D=3D> /gnu/store/7ifc22sh86zblnzamqimgmv06id=
yx69v-perl-5.26.1 3a7be40> #<graft /gnu/store/wvd2bm9zqgy2v6yw8cp9id6hw4zlw=
a4i-curl-7.59.0 =3D=3D> /gnu/store/ia117b5q4pzcm81xj1hkv2qgg898v7x5-curl-7.=
61.1 20b2c90> #<graft /gnu/store/k177ng58xf43g5v22n60g0w75pqdv339-perl-5.26=
.1 =3D=3D> /gnu/store/v6c0fksl6q8bkshwb0rb74l9n4lyjfnn-perl-5.26.1 3518360>)
--8<---------------cut here---------------end--------------->8---

In practice only a subset of these grafts are applied because, for
instance, Fish doesn=E2=80=99t depend (directly or indirectly) on Ghostscri=
pt at
run time whereas it does depend on Perl:

--8<---------------cut here---------------start------------->8---
$ guix gc -R $(guix build fish) | grep -E '(perl|ghostscript)'
/gnu/store/7ifc22sh86zblnzamqimgmv06idyx69v-perl-5.26.1
--8<---------------cut here---------------end--------------->8---

HTH!

Ludo=E2=80=99.




Information forwarded to bug-guix@HIDDEN:
bug#30265; Package guix. Full text available.

Message received at 30265 <at> debbugs.gnu.org:


Received: (at 30265) by debbugs.gnu.org; 20 Sep 2018 17:12:31 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Thu Sep 20 13:12:31 2018
Received: from localhost ([127.0.0.1]:47265 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1g32VD-0003HQ-JV
	for submit <at> debbugs.gnu.org; Thu, 20 Sep 2018 13:12:31 -0400
Received: from relay8-d.mail.gandi.net ([217.70.183.201]:33427)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <mail@HIDDEN>) id 1g32VC-0003HH-0Q
 for 30265 <at> debbugs.gnu.org; Thu, 20 Sep 2018 13:12:30 -0400
X-Originating-IP: 88.190.253.40
Received: from mimimi (unknown [88.190.253.40])
 (Authenticated sender: mail@HIDDEN)
 by relay8-d.mail.gandi.net (Postfix) with ESMTPSA id EFBF31BF206;
 Thu, 20 Sep 2018 17:12:24 +0000 (UTC)
References: <87pnx9yhsx.fsf@HIDDEN> <87o9ctdxxk.fsf@HIDDEN>
 <87efdoxia5.fsf@HIDDEN> <877ejgumrn.fsf@HIDDEN>
User-agent: mu4e 1.0; emacs 26.1
From: Pierre Neidhardt <mail@HIDDEN>
To: Ricardo Wurmus <rekado@HIDDEN>
Subject: Re: bug#30265: Fish shell has wrong path variables
In-reply-to: <877ejgumrn.fsf@HIDDEN>
Date: Thu, 20 Sep 2018 19:12:23 +0200
Message-ID: <87bm8sxfd4.fsf@HIDDEN>
MIME-Version: 1.0
Content-Type: multipart/signed; boundary="=-=-=";
 micalg=pgp-sha256; protocol="application/pgp-signature"
X-Spam-Score: -0.7 (/)
X-Debbugs-Envelope-To: 30265
Cc: Ludovic =?utf-8?Q?Court=C3=A8s?= <ludo@HIDDEN>, meiyo.peng@HIDDEN,
 30265 <at> debbugs.gnu.org, Nils Gillmann <ng0@HIDDEN>
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.7 (-)

--=-=-=
Content-Type: text/plain
Content-Transfer-Encoding: quoted-printable


> A package will be grafted when any
> of its inputs (direct or transitive) have been replaced.

I understand why that would happen when _updating_ fish, but why does it ha=
ppen
when (re-)building it from scratch, for instance when the graft source is g=
one
from the store?

=2D-=20
Pierre Neidhardt
https://ambrevar.xyz/

--=-=-=
Content-Type: application/pgp-signature; name="signature.asc"

-----BEGIN PGP SIGNATURE-----

iQEzBAEBCAAdFiEEUPM+LlsMPZAEJKvom9z0l6S7zH8FAluj1PcACgkQm9z0l6S7
zH/F6wgApMaCgiNO4asSDXxOJxB9De5ktO7MN6T1zRc0kmQWc7Z93LAXk3ZJICmM
OhT1LH1o8tf/jes5dfktA5hB/acyOKd+p2hAidGXIm3OJvQLAUyp2410NM3F8Cor
G2GE9xZkqd1Yjj8rnj8dIOlQ41fq9I6dvydEj5+PbFCWaTrMngIWxnlql8V0VTcp
1fL6toKtP+k3cwREO28a6b1kYgOAeC+5dRroXVpp7eCnB49U2dVKlRZD+QeL5I2B
Fs0xu3SEarcPCbiNlpx34GSYMcHjcmO5ISKSPhr5IsbxUKW8SrdN5zVLS1uKgb+H
3dktJsrcxsqe9Dva8z6Vf8KklnlmEQ==
=YOf0
-----END PGP SIGNATURE-----
--=-=-=--




Information forwarded to bug-guix@HIDDEN:
bug#30265; Package guix. Full text available.

Message received at 30265 <at> debbugs.gnu.org:


Received: (at 30265) by debbugs.gnu.org; 20 Sep 2018 17:01:22 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Thu Sep 20 13:01:22 2018
Received: from localhost ([127.0.0.1]:47259 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1g32KO-00031r-8v
	for submit <at> debbugs.gnu.org; Thu, 20 Sep 2018 13:01:22 -0400
Received: from sender-of-o51.zoho.com ([135.84.80.216]:21032)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <rekado@HIDDEN>) id 1g32KM-00031i-OZ
 for 30265 <at> debbugs.gnu.org; Thu, 20 Sep 2018 13:01:19 -0400
ARC-Seal: i=1; a=rsa-sha256; t=1537462854; cv=none; d=zoho.com; s=zohoarc; 
 b=JGzcedi8q1Sr3KM0C0TIO/B48bAIZcuJk7JpFM09LdEcxIyIyrD5N+Ry+aCTaKAwglZSjpc+eerxvzrc0noucj0cwbwuQVS577MTiCdXM0dD3cWa0EcuGI0RUYUebgSdY/9QXAwDijrD4n9ItbPKzNcRNV+eajSKFFRSONlBRQw=
ARC-Message-Signature: i=1; a=rsa-sha256; c=relaxed/relaxed; d=zoho.com;
 s=zohoarc; t=1537462854;
 h=Content-Type:Content-Transfer-Encoding:Cc:Date:From:In-Reply-To:MIME-Version:Message-ID:References:Subject:To:ARC-Authentication-Results;
 bh=IWW+QiNXy2APblymBxbmgN8Dl6Mnpt0rJNaAQxokk7E=; 
 b=my/jUMo9NfslGbK12GOtoVxAc9fVeQGPGc/LOp62Ku5xL8W23z0SnQs0k3eK4BDsishLgXdfJckQAbs2s1WtDG2WdfCMCk+X2a8jA/y2bxueV29Sx+X2X9dUE1QmQWuvNTI1vrIX0jCR8YyWtUEM1hgBhDQsNmMa8V9xlRiDe7w=
ARC-Authentication-Results: i=1; mx.zoho.com; dkim=pass  header.i=elephly.net;
 spf=pass  smtp.mailfrom=rekado@HIDDEN;
 dmarc=pass header.from=<rekado@HIDDEN> header.from=<rekado@HIDDEN>
DKIM-Signature: v=1; a=rsa-sha256; q=dns/txt; c=relaxed/relaxed; t=1537462854; 
 s=zoho; d=elephly.net; i=rekado@HIDDEN;
 h=References:From:To:Cc:Subject:In-reply-to:Date:Message-ID:MIME-Version:Content-Type:Content-Transfer-Encoding;
 l=1356; bh=IWW+QiNXy2APblymBxbmgN8Dl6Mnpt0rJNaAQxokk7E=;
 b=asmNpJ8JMCoTJ9F99qgwAr34Nel0ghaxLmz3WWdVN7278iAuyu7yjKSNRt8Y9Rtr
 tjqsIM6cV0BCefmlH0c8AydW+nfVx9EBLcWx92cxbKH/K9VvJqMiL9MsWJ2ZpdcoSA0
 sNUaP68h4N4sPInt7Am6xb4Fo8MbwrX/UoBoghaw=
Received: from localhost (port-92-200-93-31.dynamic.qsc.de [92.200.93.31]) by
 mx.zohomail.com with SMTPS id 1537462850189821.0485347044112;
 Thu, 20 Sep 2018 10:00:50 -0700 (PDT)
References: <87pnx9yhsx.fsf@HIDDEN> <87o9ctdxxk.fsf@HIDDEN>
 <87efdoxia5.fsf@HIDDEN>
User-agent: mu4e 1.0; emacs 26.1
From: Ricardo Wurmus <rekado@HIDDEN>
To: Pierre Neidhardt <mail@HIDDEN>
Subject: Re: bug#30265: Fish shell has wrong path variables
In-reply-to: <87efdoxia5.fsf@HIDDEN>
X-URL: https://elephly.net
X-PGP-Key: https://elephly.net/rekado.pubkey
X-PGP-Fingerprint: BCA6 89B6 3655 3801 C3C6  2150 197A 5888 235F ACAC
Date: Thu, 20 Sep 2018 19:00:44 +0200
Message-ID: <877ejgumrn.fsf@HIDDEN>
MIME-Version: 1.0
Content-Type: text/plain; charset=utf-8
Content-Transfer-Encoding: quoted-printable
X-ZohoMailClient: External
X-Spam-Score: 0.0 (/)
X-Debbugs-Envelope-To: 30265
Cc: Ludovic =?utf-8?Q?Court=C3=A8s?= <ludo@HIDDEN>, meiyo.peng@HIDDEN,
 30265 <at> debbugs.gnu.org, Nils Gillmann <ng0@HIDDEN>
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)


Pierre Neidhardt <mail@HIDDEN> writes:

> I'm not so well versed in grafting, so let me ask a few questions:
>
> - Why is fish grafted in the first place?

Almost any package can be grafted.  A package will be grafted when any
of its inputs (direct or transitive) have been replaced.  The goal of
grafting is to build a replacement package *quickly* and then only
rewrite references to the replaced package in all dependent packages.

The advantage is that dependent packages do not need to be rebuilt; they
just need to be copied, scanned for references, and have their
references updated.  This is usually *much* faster than rebuilding
all dependent packages, which may be an important consideration in
distributing security fixes.

> - Is the issue here that grafting does not support wide string literals?
>   Shouldn't we fix the Guix code to support wide strings as well?

Grafting succeeds when we can find all references to items that should
be replaced =E2=80=93 in plain text files but also in binaries.  Past probl=
ems
with grafting were triggered by compiler behaviour that chopped up these
reference strings, or by build systems that split these reference
strings.

A grafting problem is usually also a garbage collection problem, because
both depend on successful scanning for store references.

--
Ricardo





Information forwarded to bug-guix@HIDDEN:
bug#30265; Package guix. Full text available.

Message received at 30265 <at> debbugs.gnu.org:


Received: (at 30265) by debbugs.gnu.org; 20 Sep 2018 16:09:26 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Thu Sep 20 12:09:26 2018
Received: from localhost ([127.0.0.1]:47236 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1g31W9-0001jA-Uh
	for submit <at> debbugs.gnu.org; Thu, 20 Sep 2018 12:09:26 -0400
Received: from relay8-d.mail.gandi.net ([217.70.183.201]:60813)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <mail@HIDDEN>) id 1g31W8-0001iz-Ke
 for 30265 <at> debbugs.gnu.org; Thu, 20 Sep 2018 12:09:25 -0400
X-Originating-IP: 88.190.253.40
Received: from mimimi (unknown [88.190.253.40])
 (Authenticated sender: mail@HIDDEN)
 by relay8-d.mail.gandi.net (Postfix) with ESMTPSA id A76431BF219;
 Thu, 20 Sep 2018 16:09:22 +0000 (UTC)
References: <87pnx9yhsx.fsf@HIDDEN> <87o9ctdxxk.fsf@HIDDEN>
User-agent: mu4e 1.0; emacs 26.1
From: Pierre Neidhardt <mail@HIDDEN>
To: Ludovic =?utf-8?Q?Court=C3=A8s?= <ludo@HIDDEN>
Subject: Re: bug#30265: Fish shell has wrong path variables
In-reply-to: <87o9ctdxxk.fsf@HIDDEN>
Date: Thu, 20 Sep 2018 18:09:22 +0200
Message-ID: <87efdoxia5.fsf@HIDDEN>
MIME-Version: 1.0
Content-Type: multipart/signed; boundary="=-=-=";
 micalg=pgp-sha256; protocol="application/pgp-signature"
X-Spam-Score: -0.7 (/)
X-Debbugs-Envelope-To: 30265
Cc: rekado@HIDDEN, meiyo.peng@HIDDEN, 30265 <at> debbugs.gnu.org,
 Nils Gillmann <ng0@HIDDEN>
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.7 (-)

--=-=-=
Content-Type: text/plain
Content-Transfer-Encoding: quoted-printable

Thanks for this deep investigation, Ludo!

I'm not so well versed in grafting, so let me ask a few questions:

=2D Why is fish grafted in the first place?

=2D Is the issue here that grafting does not support wide string literals?
  Shouldn't we fix the Guix code to support wide strings as well?

=2D-=20
Pierre Neidhardt
https://ambrevar.xyz/

--=-=-=
Content-Type: application/pgp-signature; name="signature.asc"

-----BEGIN PGP SIGNATURE-----

iQEzBAEBCAAdFiEEUPM+LlsMPZAEJKvom9z0l6S7zH8FAlujxjIACgkQm9z0l6S7
zH9fXQf/X4xIgeDOu0uIof0OCQ6Z2kRZGIXBvOF+L/zRvNkmMvMNM7+QKaU4rk31
mmQ1uiosHQYu/8qmhqmB962TIm9I/L6+XY/a5mol22F8e46EjvU/iuDzDk589Sm0
MUHSG/7Jp3xGbraUuQ4hXrsxaMYrVqfsi3+iE8pOzAtn0pb1gk/8sEp2GGwBP4Ke
66Qzv0uOEHUsq0gntqR/up2pFzgOs/Fd16kopVtJSanFM5Sun4mdK/tNZrpzcOHt
dVg4Qhx6QsKSv/7u25CQ7IUgYjmaf407rKk0vE4SO8ta4Uq6HC/j1rh1J4mq6cuW
AmzoYC8nlrju/Xyh7k5rymbXr6a4lw==
=H7uz
-----END PGP SIGNATURE-----
--=-=-=--




Information forwarded to bug-guix@HIDDEN:
bug#30265; Package guix. Full text available.

Message received at 30265 <at> debbugs.gnu.org:


Received: (at 30265) by debbugs.gnu.org; 19 Sep 2018 20:41:49 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Wed Sep 19 16:41:49 2018
Received: from localhost ([127.0.0.1]:46057 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1g2jID-0007Ts-0T
	for submit <at> debbugs.gnu.org; Wed, 19 Sep 2018 16:41:49 -0400
Received: from eggs.gnu.org ([208.118.235.92]:54484)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <ludo@HIDDEN>) id 1g2jIB-0007Tc-Hs
 for 30265 <at> debbugs.gnu.org; Wed, 19 Sep 2018 16:41:47 -0400
Received: from Debian-exim by eggs.gnu.org with spam-scanned (Exim 4.71)
 (envelope-from <ludo@HIDDEN>) id 1g2jI5-0008Vd-FH
 for 30265 <at> debbugs.gnu.org; Wed, 19 Sep 2018 16:41:42 -0400
X-Spam-Checker-Version: SpamAssassin 3.3.2 (2011-06-06) on eggs.gnu.org
X-Spam-Level: 
X-Spam-Status: No, score=-0.0 required=5.0 tests=BAYES_40 autolearn=disabled
 version=3.3.2
Received: from fencepost.gnu.org ([2001:4830:134:3::e]:49546)
 by eggs.gnu.org with esmtp (Exim 4.71) (envelope-from <ludo@HIDDEN>)
 id 1g2jFp-0005gA-QO; Wed, 19 Sep 2018 16:39:21 -0400
Received: from [2a01:e0a:1d:7270:af76:b9b:ca24:c465] (port=33684 helo=ribbon)
 by fencepost.gnu.org with esmtpsa (TLS1.2:RSA_AES_256_CBC_SHA1:256)
 (Exim 4.82) (envelope-from <ludo@HIDDEN>)
 id 1g2jFp-0004ue-Ie; Wed, 19 Sep 2018 16:39:21 -0400
From: ludo@HIDDEN (Ludovic =?utf-8?Q?Court=C3=A8s?=)
To: Pierre Neidhardt <mail@HIDDEN>
Subject: Re: bug#30265: Fish shell has wrong path variables
References: <87pnx9yhsx.fsf@HIDDEN>
X-URL: http://www.fdn.fr/~lcourtes/
X-Revolutionary-Date: Jour du Travail de =?utf-8?Q?l'Ann=C3=A9e?= 226 de la
 =?utf-8?Q?R=C3=A9volution?=
X-PGP-Key-ID: 0x090B11993D9AEBB5
X-PGP-Key: http://www.fdn.fr/~lcourtes/ludovic.asc
X-PGP-Fingerprint: 3CE4 6455 8A84 FDC6 9DB4  0CFB 090B 1199 3D9A EBB5
X-OS: x86_64-pc-linux-gnu
Date: Wed, 19 Sep 2018 22:39:19 +0200
In-Reply-To: <87pnx9yhsx.fsf@HIDDEN> (Pierre Neidhardt's message of
 "Wed, 19 Sep 2018 11:09:50 +0200")
Message-ID: <87o9ctdxxk.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/26.1 (gnu/linux)
MIME-Version: 1.0
Content-Type: text/plain; charset=utf-8
Content-Transfer-Encoding: quoted-printable
X-detected-operating-system: by eggs.gnu.org: GNU/Linux 2.2.x-3.x [generic]
X-Received-From: 2001:4830:134:3::e
X-Spam-Score: -5.0 (-----)
X-Debbugs-Envelope-To: 30265
Cc: rekado@HIDDEN, meiyo.peng@HIDDEN, 30265 <at> debbugs.gnu.org,
 Nils Gillmann <ng0@HIDDEN>
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -6.0 (------)

Hi Pierre,

Pierre Neidhardt <mail@HIDDEN> skribis:

> I think Ricardo got a hunch of what's happening, except that it's not
> about cache files in the user home's directory.  Instead, Fish seems to
> record the path to the graft source.  A grep in the fish folder does not
> seem to reveal anything, nor does `strings
> /gnu/store/...-fish.../bin/fish`.
>
> Could this be a grafting issue?  Like what was recently mentioned about
> Racket?

It may well be a reference that doesn=E2=80=99t get properly grafted.  We c=
an
see it when running the grafted fish under =E2=80=98strace=E2=80=99.

The culprit is this bit from fish.cpp:

        // Fall back to what got compiled in.
        debug(2, L"Using compiled in paths:");
        paths.data =3D L"" DATADIR "/fish";
        paths.sysconf =3D L"" SYSCONFDIR "/fish";
        paths.doc =3D L"" DOCDIR;
        paths.bin =3D L"" BINDIR;

The =E2=80=9CL=E2=80=9D here means these are =E2=80=9Cwide string=E2=80=9D =
literals, and indeed, the
=E2=80=9CUsing=E2=80=A6=E2=80=9D string above looks like this in the ELF fi=
le:

001140d0: 5500 0000 7300 0000 6900 0000 6e00 0000  U...s...i...n...
001140e0: 6700 0000 2000 0000 6300 0000 6f00 0000  g... ...c...o...
001140f0: 6d00 0000 7000 0000 6900 0000 6c00 0000  m...p...i...l...
00114100: 6500 0000 6400 0000 2000 0000 6900 0000  e...d... ...i...
00114110: 6e00 0000 2000 0000 7000 0000 6100 0000  n... ...p...a...
00114120: 7400 0000 6800 0000 7300 0000 3a00 0000  t...h...s...:...

The DATADIR literal is similarly =E2=80=9Chidden=E2=80=9D, and thus the gra=
fting code
doesn=E2=80=99t see it.

Possible fixes include:

  1. Finding a way to make the run-time detection in
     =E2=80=98determine_config_directory_paths=E2=80=99 to always work with=
out going to
     the fallback case where it relies on string literals.  This could
     be done by attempting to read /proc/self/exe (on GNU/Linux) instead
     of relying on argv0.

  2. Using =E2=80=9Cregular=E2=80=9D strings, or at least arranging to stor=
e DATADIR &
     co. in regular =E2=80=9Cconst char=E2=80=9D arrays.  Maybe something l=
ike:

       static const char datadir[] =3D DATADIR;

       =E2=80=A6

       paths.data =3D L"" + datadir + L"/fish";

     It probably takes some more casts from char[] to std::string to
     wcstring, but you get the idea.  ;-)

Thoughts?

Ludo=E2=80=99.




Information forwarded to bug-guix@HIDDEN:
bug#30265; Package guix. Full text available.

Message received at 30265 <at> debbugs.gnu.org:


Received: (at 30265) by debbugs.gnu.org; 19 Sep 2018 09:09:56 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Wed Sep 19 05:09:56 2018
Received: from localhost ([127.0.0.1]:45134 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1g2YUd-0000Bf-Su
	for submit <at> debbugs.gnu.org; Wed, 19 Sep 2018 05:09:56 -0400
Received: from relay4-d.mail.gandi.net ([217.70.183.196]:43297)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <mail@HIDDEN>) id 1g2YUb-0000BW-W4
 for 30265 <at> debbugs.gnu.org; Wed, 19 Sep 2018 05:09:54 -0400
X-Originating-IP: 88.190.253.40
Received: from mimimi (unknown [88.190.253.40])
 (Authenticated sender: mail@HIDDEN)
 by relay4-d.mail.gandi.net (Postfix) with ESMTPSA id 32BE4E000A;
 Wed, 19 Sep 2018 09:09:51 +0000 (UTC)
User-agent: mu4e 1.0; emacs 26.1
From: Pierre Neidhardt <mail@HIDDEN>
To: 30265 <at> debbugs.gnu.org
Subject: Re: bug#30265: Fish shell has wrong path variables
Date: Wed, 19 Sep 2018 11:09:50 +0200
Message-ID: <87pnx9yhsx.fsf@HIDDEN>
MIME-Version: 1.0
Content-Type: multipart/signed; boundary="=-=-=";
 micalg=pgp-sha256; protocol="application/pgp-signature"
X-Spam-Score: -0.7 (/)
X-Debbugs-Envelope-To: 30265
Cc: rekado@HIDDEN, Ludovic =?utf-8?Q?Court=C3=A8s?= <ludo@HIDDEN>,
 meiyo.peng@HIDDEN, Nils Gillmann <ng0@HIDDEN>
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.7 (-)

--=-=-=
Content-Type: text/plain

I haven't investigated too deep into this, but I've figured out a few
things.

First of all, to reproduce the issue:

- Install fish.

- Run `guix build --check fish`, it should output something like

  #+BEGIN_SRC sh
  > guix build --check fish
  Building /gnu/store/g9ra27952ay2a7j3mn7yp13b7m18kl1b-fish-2.7.1.drv - x86_64-linux
  grafting '/gnu/store/vgrav12zra9zky21ahm4x1qg8g4v58fj-fish-2.7.1' -> '/gnu/store/avk637800w1n7z1z0hnzx80r0fpd6729-fish-2.7.1'...
  /gnu/store/avk637800w1n7z1z0hnzx80r0fpd6729-fish-2.7.1
  #+END_SRC

- The graft source is a dead GC item:
	#+BEGIN_SRC sh
	> guix gc --list-dead | grep vgrav12zra9zky21ahm4x1qg8g4v58fj
	/gnu/store/vgrav12zra9zky21ahm4x1qg8g4v58fj-fish-2.7.1
	#+END_SRC

  Collect it:
	#+BEGIN_SRC sh
  guix gc --delete /gnu/store/vgrav12zra9zky21ahm4x1qg8g4v58fj-fish-2.7.1
	#+END_SRC

- Start fish:
  #+BEGIN_SRC sh
  > fish
  fish:
  echo $_ " "; __fish_pwd
                 ^
  in command substitution
          called on standard input
  ...
  #+END_SRC

I think Ricardo got a hunch of what's happening, except that it's not
about cache files in the user home's directory.  Instead, Fish seems to
record the path to the graft source.  A grep in the fish folder does not
seem to reveal anything, nor does `strings
/gnu/store/...-fish.../bin/fish`.

Could this be a grafting issue?  Like what was recently mentioned about
Racket?

Otherwise, as Meiyo pointed out, the solution might lie in patching
fish.cpp if grafting is not responsible for this.

--
Pierre Neidhardt
https://ambrevar.xyz/

--=-=-=
Content-Type: application/pgp-signature; name="signature.asc"

-----BEGIN PGP SIGNATURE-----

iQEzBAEBCAAdFiEEUPM+LlsMPZAEJKvom9z0l6S7zH8FAluiEl4ACgkQm9z0l6S7
zH/dYQf/RtmcrvyaEQl1MIHNXn1MBT+FTiHWnwcPTV7/70pwhlXwuNj+qX3Y+xqq
RO9mfHGTmX2p66vq7aQxEKVrzQLAr+WH+wEMQsQst2aiU+5nwvjGoWRhW53FFuAN
sK4kDCdpvO6nNMZk75hwbIuCprWoEqcHmIO3yoWr2lurbjvPRYskPVV3m44wMxSF
Jz8f6v4BWYv2uktFXmI1Pom9nJ5MnKWp86/JqequySab88LfOiJ+uVqujfC5Dx9Q
N/HXl/qaMcRMgyG+zHtV6uO0A9vPdUYm5gSU3rPAWb7/wjLrKOhizxRXpLdH9DiF
XnqF6QKi0uGF4EnJ+Cn29GN0wbEnPg==
=d86p
-----END PGP SIGNATURE-----
--=-=-=--




Information forwarded to bug-guix@HIDDEN:
bug#30265; Package guix. Full text available.

Message received at 30265 <at> debbugs.gnu.org:


Received: (at 30265) by debbugs.gnu.org; 27 Jan 2018 18:19:40 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Sat Jan 27 13:19:40 2018
Received: from localhost ([127.0.0.1]:45484 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1efV4m-0001ys-9a
	for submit <at> debbugs.gnu.org; Sat, 27 Jan 2018 13:19:40 -0500
Received: from aibo.runbox.com ([91.220.196.211]:44798)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <ng0@HIDDEN>) id 1efV4j-0001yi-Gh
 for 30265 <at> debbugs.gnu.org; Sat, 27 Jan 2018 13:19:38 -0500
Received: from [10.9.9.210] (helo=mailfront10.runbox.com)
 by mailtransmit02.runbox with esmtp (Exim 4.86_2)
 (envelope-from <ng0@HIDDEN>) id 1efV4i-00028y-9n
 for 30265 <at> debbugs.gnu.org; Sat, 27 Jan 2018 19:19:36 +0100
Received: from dslb-088-078-030-190.088.078.pools.vodafone-ip.de
 ([88.78.30.190] helo=localhost)
 by mailfront10.runbox.com with esmtpsa (uid:892961 )
 (TLS1.2:RSA_AES_256_CBC_SHA1:256) (Exim 4.82) id 1efV4a-0006eU-QT
 for 30265 <at> debbugs.gnu.org; Sat, 27 Jan 2018 19:19:28 +0100
From: ng0 <ng0@HIDDEN>
To: 30265 <at> debbugs.gnu.org
Subject: Re: bug#30265: Fish shell has wrong path variables
In-Reply-To: <87bmhf1d7k.fsf@HIDDEN> ("Ludovic =?utf-8?Q?Court=C3=A8s=22'?=
 =?utf-8?Q?s?= message of "Sat, 27 Jan 2018 17:25:03 +0100")
References: <87inbnpsx9.fsf@HIDDEN>
 <87shar8u6d.fsf@HIDDEN>
 <87bmhf1d7k.fsf@HIDDEN>
Date: Sat, 27 Jan 2018 18:19:29 +0000
Message-ID: <878tcjjham.fsf@HIDDEN>
MIME-Version: 1.0
Content-Type: text/plain; charset=utf-8
Content-Transfer-Encoding: 8bit
X-Spam-Score: -0.7 (/)
X-Debbugs-Envelope-To: 30265
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -0.7 (/)

On Sat, 27 Jan 2018, ludo@HIDDEN (Ludovic Courtès) wrote:
> Hi ng0 and Meiyo,
>
> ng0@HIDDEN skribis:
>
>> On Sat, 27 Jan 2018, Meiyo Peng <meiyo.peng@HIDDEN> wrote:
>>> Hi,
>>>
>>> I am using GuixSD 0.14. After upgrading fish shell to latest version(v2.7.1) and
>>> running `guix gc`, fish shell does not work well.
>>
>> Can you explain a bit more about your setup? I assume you use
>> fish as you user shell and not just as a shell you switch into
>> from a Bash enabled user, correct?
>
> Note that the current ‘guix’ package, 0.14.0-7.33988f9, includes Fish
> completion support, which was not the case before:
>
> --8<---------------cut here---------------start------------->8---
> $ ls -R $(guix build guix)/share/fish
> /gnu/store/apji9j8cwf9xpd5jk5mk8s6r1a391yvq-guix-0.14.0-7.33988f9/share/fish:
> vendor_completions.d
>
> /gnu/store/apji9j8cwf9xpd5jk5mk8s6r1a391yvq-guix-0.14.0-7.33988f9/share/fish/vendor_completions.d:
> guix.fish
> --8<---------------cut here---------------end--------------->8---
>
> Could it be the reason why you’re having problems now that you didn’t
> experience earlier?
>
> Any ideas, ng0?
>
> Thanks,
> Ludo’.
>
>
>
>

No, I'm pretty sure this has nothing to do with adding fish
support to Guix.
-- 
ng0 :: https://ea.n0.is
A88C8ADD129828D7EAC02E52E22F9BBFEE348588 :: https://ea.n0.is/keys/




Information forwarded to bug-guix@HIDDEN:
bug#30265; Package guix. Full text available.

Message received at 30265 <at> debbugs.gnu.org:


Received: (at 30265) by debbugs.gnu.org; 27 Jan 2018 16:25:08 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Sat Jan 27 11:25:08 2018
Received: from localhost ([127.0.0.1]:45431 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1efTHw-00076Q-I2
	for submit <at> debbugs.gnu.org; Sat, 27 Jan 2018 11:25:08 -0500
Received: from hera.aquilenet.fr ([185.233.100.1]:42414)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <ludo@HIDDEN>) id 1efTHv-00076I-5z
 for 30265 <at> debbugs.gnu.org; Sat, 27 Jan 2018 11:25:07 -0500
Received: from localhost (localhost [127.0.0.1])
 by hera.aquilenet.fr (Postfix) with ESMTP id 94BB610969;
 Sat, 27 Jan 2018 17:25:06 +0100 (CET)
X-Virus-Scanned: Debian amavisd-new at aquilenet.fr
Received: from hera.aquilenet.fr ([127.0.0.1])
 by localhost (hera.aquilenet.fr [127.0.0.1]) (amavisd-new, port 10024)
 with ESMTP id 00GlREBB7waq; Sat, 27 Jan 2018 17:25:05 +0100 (CET)
Received: from ribbon (unknown [IPv6:2a01:e0a:1d:7270:af76:b9b:ca24:c465])
 by hera.aquilenet.fr (Postfix) with ESMTPSA id B104C10520;
 Sat, 27 Jan 2018 17:25:04 +0100 (CET)
From: ludo@HIDDEN (Ludovic =?utf-8?Q?Court=C3=A8s?=)
To: ng0@HIDDEN, Meiyo Peng <meiyo.peng@HIDDEN>
Subject: Re: bug#30265: Fish shell has wrong path variables
References: <87inbnpsx9.fsf@HIDDEN>
 <87shar8u6d.fsf@HIDDEN>
X-URL: http://www.fdn.fr/~lcourtes/
X-Revolutionary-Date: 8 =?utf-8?Q?Pluvi=C3=B4se?= an 226 de la =?utf-8?Q?R?=
 =?utf-8?Q?=C3=A9volution?=
X-PGP-Key-ID: 0x090B11993D9AEBB5
X-PGP-Key: http://www.fdn.fr/~lcourtes/ludovic.asc
X-PGP-Fingerprint: 3CE4 6455 8A84 FDC6 9DB4  0CFB 090B 1199 3D9A EBB5
X-OS: x86_64-pc-linux-gnu
Date: Sat, 27 Jan 2018 17:25:03 +0100
In-Reply-To: <87shar8u6d.fsf@HIDDEN>
 (ng0@HIDDEN's message of "Sat, 27 Jan 2018 10:36:42 +0000")
Message-ID: <87bmhf1d7k.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/25.3 (gnu/linux)
MIME-Version: 1.0
Content-Type: text/plain; charset=utf-8
Content-Transfer-Encoding: quoted-printable
X-Spam-Score: 1.0 (+)
X-Debbugs-Envelope-To: 30265
Cc: 30265 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: 1.0 (+)

Hi ng0 and Meiyo,

ng0@HIDDEN skribis:

> On Sat, 27 Jan 2018, Meiyo Peng <meiyo.peng@HIDDEN> wrote:
>> Hi,
>>
>> I am using GuixSD 0.14. After upgrading fish shell to latest version(v2.=
7.1) and
>> running `guix gc`, fish shell does not work well.
>
> Can you explain a bit more about your setup? I assume you use
> fish as you user shell and not just as a shell you switch into
> from a Bash enabled user, correct?

Note that the current =E2=80=98guix=E2=80=99 package, 0.14.0-7.33988f9, inc=
ludes Fish
completion support, which was not the case before:

--8<---------------cut here---------------start------------->8---
$ ls -R $(guix build guix)/share/fish
/gnu/store/apji9j8cwf9xpd5jk5mk8s6r1a391yvq-guix-0.14.0-7.33988f9/share/fis=
h:
vendor_completions.d

/gnu/store/apji9j8cwf9xpd5jk5mk8s6r1a391yvq-guix-0.14.0-7.33988f9/share/fis=
h/vendor_completions.d:
guix.fish
--8<---------------cut here---------------end--------------->8---

Could it be the reason why you=E2=80=99re having problems now that you didn=
=E2=80=99t
experience earlier?

Any ideas, ng0?

Thanks,
Ludo=E2=80=99.




Information forwarded to bug-guix@HIDDEN:
bug#30265; Package guix. Full text available.

Message received at 30265 <at> debbugs.gnu.org:


Received: (at 30265) by debbugs.gnu.org; 27 Jan 2018 14:13:29 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Sat Jan 27 09:13:29 2018
Received: from localhost ([127.0.0.1]:44497 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1efREW-0003L6-LR
	for submit <at> debbugs.gnu.org; Sat, 27 Jan 2018 09:13:28 -0500
Received: from mail-pl0-f43.google.com ([209.85.160.43]:43569)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <meiyo.peng@HIDDEN>) id 1efREU-0003Kq-Jx
 for 30265 <at> debbugs.gnu.org; Sat, 27 Jan 2018 09:13:27 -0500
Received: by mail-pl0-f43.google.com with SMTP id f4so721148plr.10
 for <30265 <at> debbugs.gnu.org>; Sat, 27 Jan 2018 06:13:26 -0800 (PST)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=gmail.com; s=20161025;
 h=from:to:cc:subject:date:message-id:mime-version;
 bh=dkPZY7DIPqN4Ljyx4nFOs2abhbeVHO/gdBPR57xRpeY=;
 b=CegsKgsPj+++fMD0n1Tev1aRB8dR+orLvd8hK0qpHVYGE54fL6TNOSsqZNPGzJ6BAl
 kEKUBngeh2D5mQOueLvlYcDIYm1IGa7eEiCnyABIs1LpWQPz+B9yDvTfYuc6FwbToW7+
 ntoBrIhYlq3biTQ29PzNTZsY5gvGD3pQ7ywykTfMphGsGCbFVGyDpMWST25nSGkfMMUp
 9JeghH0Ei/iR7sbS/gstxjmmrh/6YnndJOI3GQrHapuAlOCINkIjPOD4vbNe2nS+A5d3
 gLmKgFMpxuMXfDHKOzCw2k02Jn0XhBepLN3UsXO8PBNoD0xkEHcpeDBC+lXpX7Hvf5of
 Jtuw==
X-Google-DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed;
 d=1e100.net; s=20161025;
 h=x-gm-message-state:from:to:cc:subject:date:message-id:mime-version;
 bh=dkPZY7DIPqN4Ljyx4nFOs2abhbeVHO/gdBPR57xRpeY=;
 b=JptmKVy32NH51DfK72lz72TLT66zyH0NMlx770FAdcR9NgGMJB4UR6SQwnRGaS7Vxx
 A6CvQ62cPJn/2Ya8YSZmKVCx32V2+3ym9HY051CCGc0v1t0u5SMR2CWpwupJ1UfCrQim
 3FL6ygm1ZupqYT4NK4rX3x/wPltsm77tF+3jZWocsiVN983EWTbc1998xMtda1+tNLA+
 FsvAWT6vXX13t0yz22Eti4C1IrGpCfil5qzY0bmhwTxFDx1BxPLA3WgLSti55YQcI4pb
 CrEPN9t9/rMqCM8y8us9jPVy9nZLgBqkS81M18918/tYc7V5kB4bOys6Tn/IRZ5cJQ6i
 7WQQ==
X-Gm-Message-State: AKwxytf5JDO9BUSZnnwihmycTZth4sYVJeQH5CET3JcB5/qMargxcY9N
 KRDy9XF+Z1ojDHLE7i/VBsqK+7bx
X-Google-Smtp-Source: AH8x227y4+OHrBWpgLvDtxRqMtt7z4tTyH8M/LN+RPcqxOTHKYPA+uJVaNHAnn9VjsHnLT6TZiFbag==
X-Received: by 2002:a17:902:6e01:: with SMTP id
 u1-v6mr17116191plk.12.1517062400156; 
 Sat, 27 Jan 2018 06:13:20 -0800 (PST)
Received: from sid (110.242.201.35.bc.googleusercontent.com. [35.201.242.110])
 by smtp.gmail.com with ESMTPSA id
 t22sm23799611pfi.118.2018.01.27.06.13.17 for <30265 <at> debbugs.gnu.org>
 (version=TLS1_2 cipher=ECDHE-RSA-CHACHA20-POLY1305 bits=256/256);
 Sat, 27 Jan 2018 06:13:18 -0800 (PST)
From: Meiyo Peng <meiyo.peng@HIDDEN>
To: 30265 <at> debbugs.gnu.org
Subject: Re: bug#30265: Fish shell has wrong path variables
Date: Sat, 27 Jan 2018 22:13:16 +0800
Message-ID: <87lggjgzk3.fsf@HIDDEN>
MIME-Version: 1.0
Content-Type: text/plain
X-Spam-Score: 0.0 (/)
X-Debbugs-Envelope-To: 30265
Cc: 30265 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: 0.0 (/)


ng0 wrote:
> Can you explain a bit more about your setup? I assume you use
> fish as you user shell and not just as a shell you switch into
> from a Bash enabled user, correct?

My GuixSD is a fresh setup. I did no customization to fish and did not
set fish as login shell.

The bug I reported is reproducible. I tried it in a virtual machine
several times.
1. Install GuixSD 0.14 with fish
2. guix pull
3. Upgrade all packages
4. guix gc
5. Start a fish shell, and the bug I reported occur




Information forwarded to bug-guix@HIDDEN:
bug#30265; Package guix. Full text available.

Message received at 30265 <at> debbugs.gnu.org:


Received: (at 30265) by debbugs.gnu.org; 27 Jan 2018 13:45:29 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Sat Jan 27 08:45:29 2018
Received: from localhost ([127.0.0.1]:44473 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1efQnQ-0002cA-PX
	for submit <at> debbugs.gnu.org; Sat, 27 Jan 2018 08:45:28 -0500
Received: from mail-pg0-f46.google.com ([74.125.83.46]:45807)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <meiyo.peng@HIDDEN>) id 1efQnN-0002bu-Vm
 for 30265 <at> debbugs.gnu.org; Sat, 27 Jan 2018 08:45:26 -0500
Received: by mail-pg0-f46.google.com with SMTP id m136so1717056pga.12
 for <30265 <at> debbugs.gnu.org>; Sat, 27 Jan 2018 05:45:25 -0800 (PST)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=gmail.com; s=20161025;
 h=from:to:cc:subject:references:date:in-reply-to:message-id
 :user-agent:mime-version:content-transfer-encoding;
 bh=4KEAXgjBmn1JRYY+mQ1XkLgClC1ru4rJETt4GMPHjFs=;
 b=pVASOgJF4j577NGWpsxzq+upP0hTY+GtDVREV9iL5PQx3hz+bYv1JDoQJJKyvRG8cz
 ACPbmL077C5ObYETFkDPBchN7sVgIdz9ETB2S3v5RXjgg7iZWl2CNZYf2NWuThkTunWo
 tqVTi/yrEp9i7G+KxT1l63nSudyxmMGzZVozxHXR0R5gAPFJUEGNmP9zVM+glj45OZvy
 p1uejp9jCYX7Cd6SpSptcZMUb322yP/dGs47WQe/h+Kf/gZ848v1slxYHP6Bc/mK2vxn
 zdn9Ao+u/whabJrJshuKxTgSJZXsUiOm4vzaLoRUlh/leviyB+N6LgF32TLGHNxsn6Uq
 YJEA==
X-Google-DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed;
 d=1e100.net; s=20161025;
 h=x-gm-message-state:from:to:cc:subject:references:date:in-reply-to
 :message-id:user-agent:mime-version:content-transfer-encoding;
 bh=4KEAXgjBmn1JRYY+mQ1XkLgClC1ru4rJETt4GMPHjFs=;
 b=Q3w88+pMStWV6yKLakPfBOSi27Z0p1SNwu5y/JRvi3tE5jCjJcJIGP3pmqsBTiNPVR
 gccGh4cEPbeuM7/R8iekiOl9QqZrO1rfemK416wcBWGEvgnutGHd+meWU55UaIHlDSCN
 IB5vtu7jtsWkE3cMVck/2E+bklOsR3nGTP42N6teb3QIPEl1MLMCO+zD9lT4lQAKMGSF
 /9FkcdaPNA9zskpz6QXBh+dNvys3EA5yMxLXynWS2mrXcL0pWaHZu5U3xuHfGXgWQKUe
 awW2+kQDEIANIj6CI60jZ+L+10hAvP0fFLhmdvDRiQXCJWwSFIhnkgYvoGSXkps2wgHq
 xZwg==
X-Gm-Message-State: AKwxytehInK2/mc8o27c1/NGWSExJF31FIC5d2JtCWfoDVYOmjDpLCJN
 014253BnwbCGs4Bs+XCArSVC3mic
X-Google-Smtp-Source: AH8x2267NcNpCBbLpjSe6t9F768kbAzBIPa7rSIxvSJc9Ksbld57iVxywuziScfb7kS4IN0v1LL6Xg==
X-Received: by 10.99.6.14 with SMTP id 14mr17637910pgg.8.1517060719443;
 Sat, 27 Jan 2018 05:45:19 -0800 (PST)
Received: from sid (110.242.201.35.bc.googleusercontent.com. [35.201.242.110])
 by smtp.gmail.com with ESMTPSA id
 z19sm26266122pff.3.2018.01.27.05.45.16
 (version=TLS1_2 cipher=ECDHE-RSA-CHACHA20-POLY1305 bits=256/256);
 Sat, 27 Jan 2018 05:45:18 -0800 (PST)
From: Meiyo Peng <meiyo.peng@HIDDEN>
To: Ricardo Wurmus <rekado@HIDDEN>
Subject: Re: bug#30265: Fish shell has wrong path variables
References: <87inbnpsx9.fsf@HIDDEN> <87inbntryj.fsf@HIDDEN>
Date: Sat, 27 Jan 2018 21:45:15 +0800
In-Reply-To: <87inbntryj.fsf@HIDDEN> (Ricardo Wurmus's message of "Sat,
 27 Jan 2018 13:19:00 +0100")
Message-ID: <87wp03h0us.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/27.0.50 (gnu/linux)
MIME-Version: 1.0
Content-Type: text/plain; charset=utf-8
Content-Transfer-Encoding: quoted-printable
X-Spam-Score: -0.0 (/)
X-Debbugs-Envelope-To: 30265
Cc: 30265 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -0.0 (/)

Ricardo Wurmus <rekado@HIDDEN> writes:

> Where are these environment variables defined?
According to `share/fish/config.fish`, they are defined in fish.cpp.
#+BEGIN_SRC fish
  # __fish_datadir, __fish_sysconfdir, __fish_help_dir, __fish_bin_dir
  # are expected to have been set up by read_init from fish.cpp
#+END_SRC

You can get fish shell's environment variables using fish's `set` command.
A single `set` without argument will print all environment variables.

> The question is whether these old store references are kept in files
> outside of the store (and thus are not directly under our control), or
> if the packages that Guix builds include incorrect references.  I guess
> that it=E2=80=99s the former.
>
> As is the case for these other programmes that record paths in cache
> files, we would need to patch fish to record only the stable names of
> links to those files (e.g. ~/.guix-profile/foo/bar) rather than the
> actual file names in the store, which may disappear upon =E2=80=9Cguix gc=
=E2=80=9D.
>
Maybe you are right. Guix is still new to me, so I do not know details
about guix's mechanism.


Meiyo Peng




Information forwarded to bug-guix@HIDDEN:
bug#30265; Package guix. Full text available.

Message received at 30265 <at> debbugs.gnu.org:


Received: (at 30265) by debbugs.gnu.org; 27 Jan 2018 12:19:24 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Sat Jan 27 07:19:24 2018
Received: from localhost ([127.0.0.1]:44424 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1efPS8-0004vf-0a
	for submit <at> debbugs.gnu.org; Sat, 27 Jan 2018 07:19:24 -0500
Received: from sender-of-o51.zoho.com ([135.84.80.216]:21103)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <rekado@HIDDEN>) id 1efPS6-0004vV-E0
 for 30265 <at> debbugs.gnu.org; Sat, 27 Jan 2018 07:19:22 -0500
DKIM-Signature: v=1; a=rsa-sha256; q=dns/txt; c=relaxed/relaxed; t=1517055543; 
 s=zoho; d=elephly.net; i=rekado@HIDDEN;
 h=References:From:To:Cc:Subject:In-reply-to:Date:MIME-Version:Content-Type:Content-Transfer-Encoding:Message-ID;
 l=1710; bh=H0rUsx8zz9dwkPkJJZd03dX3TzrgtOjtuMhMhmlyNGE=;
 b=RNt26Svk0vauHpFe/d/jGPgIdeGNVrZR44JsxWqSdNgSmdfbGcmqIigoV2H0DiY6
 mTbNQWLW5dvky+Z7phTGNfJab4lHdYuKbBB2ZYYj4UW31ERhsqJtqqJxwK2DSW/kbWz
 g6/YzdfKXoCTAW47IFVri+1TjLL6EwKovAHm0IMg=
Received: from localhost (port-92-200-155-127.dynamic.qsc.de [92.200.155.127])
 by mx.zohomail.com with SMTPS id 1517055543695908.5557093197749;
 Sat, 27 Jan 2018 04:19:03 -0800 (PST)
References: <87inbnpsx9.fsf@HIDDEN>
User-agent: mu4e 1.0-alpha3; emacs 25.3.1
From: Ricardo Wurmus <rekado@HIDDEN>
To: Meiyo Peng <meiyo.peng@HIDDEN>
Subject: Re: bug#30265: Fish shell has wrong path variables
In-reply-to: <87inbnpsx9.fsf@HIDDEN>
X-URL: https://elephly.net
X-PGP-Key: https://elephly.net/rekado.pubkey
X-PGP-Fingerprint: BCA6 89B6 3655 3801 C3C6  2150 197A 5888 235F ACAC
Date: Sat, 27 Jan 2018 13:19:00 +0100
MIME-Version: 1.0
Content-Type: text/plain; charset=utf-8
Content-Transfer-Encoding: quoted-printable
Message-ID: <87inbntryj.fsf@HIDDEN>
X-ZohoMailClient: External
X-Spam-Score: 0.0 (/)
X-Debbugs-Envelope-To: 30265
Cc: 30265 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: 0.0 (/)


Hi Meiyo,

thanks for the report.

> I am using GuixSD 0.14. After upgrading fish shell to latest version(v2.7=
.1) and
> running `guix gc`, fish shell does not work well.
[=E2=80=A6]
> Fish shell is installed in:
> #+BEGIN_EXAMPLE
>   /gnu/store/ajbbi9cgj9j0my7v5habp0lcysaf2a51-fish-2.7.1/
> #+END_EXAMPLE
>
> But the environment variable $fish_function_path does not exist. And thes=
e
> environment variables point to non-existent paths:
> #+BEGIN_EXAMPLE
>   __fish_bin_dir /gnu/store/4jkxcz8kpy621ycmqn3rvs0fv6c98h6p-fish-2.7.1/b=
in
>   __fish_datadir /gnu/store/4jkxcz8kpy621ycmqn3rvs0fv6c98h6p-fish-2.7.1/s=
hare/fish
> #+END_EXAMPLE

Where are these environment variables defined?

> In conclusion, I think some path related variables are not set
> correctly when fish is compiled from source code and that caused the
> bug I met.

Some other packages record exact store references in cache files in the
user=E2=80=99s home directory.  As packages get upgraded and removed after
garbage collection, these references become invalid.

The question is whether these old store references are kept in files
outside of the store (and thus are not directly under our control), or
if the packages that Guix builds include incorrect references.  I guess
that it=E2=80=99s the former.

As is the case for these other programmes that record paths in cache
files, we would need to patch fish to record only the stable names of
links to those files (e.g. ~/.guix-profile/foo/bar) rather than the
actual file names in the store, which may disappear upon =E2=80=9Cguix gc=
=E2=80=9D.

--
Ricardo

GPG: BCA6 89B6 3655 3801 C3C6  2150 197A 5888 235F ACAC
https://elephly.net






Information forwarded to bug-guix@HIDDEN:
bug#30265; Package guix. Full text available.

Message received at 30265 <at> debbugs.gnu.org:


Received: (at 30265) by debbugs.gnu.org; 27 Jan 2018 10:36:50 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Sat Jan 27 05:36:50 2018
Received: from localhost ([127.0.0.1]:44402 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1efNqs-0002Eu-EK
	for submit <at> debbugs.gnu.org; Sat, 27 Jan 2018 05:36:50 -0500
Received: from aibo.runbox.com ([91.220.196.211]:52918)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <ng0@HIDDEN>) id 1efNqq-0002El-4w
 for 30265 <at> debbugs.gnu.org; Sat, 27 Jan 2018 05:36:48 -0500
Received: from [10.9.9.211] (helo=mailfront11.runbox.com)
 by mailtransmit03.runbox with esmtp (Exim 4.86_2)
 (envelope-from <ng0@HIDDEN>) id 1efNqp-0005Un-5X
 for 30265 <at> debbugs.gnu.org; Sat, 27 Jan 2018 11:36:47 +0100
Received: from dslb-088-078-030-190.088.078.pools.vodafone-ip.de
 ([88.78.30.190] helo=localhost)
 by mailfront11.runbox.com with esmtpsa (uid:892961 )
 (TLS1.2:RSA_AES_256_CBC_SHA1:256) (Exim 4.82) id 1efNqj-0008L4-PT
 for 30265 <at> debbugs.gnu.org; Sat, 27 Jan 2018 11:36:41 +0100
From: ng0@HIDDEN
To: 30265 <at> debbugs.gnu.org
Subject: Re: bug#30265: Fish shell has wrong path variables
In-Reply-To: <87inbnpsx9.fsf@HIDDEN> (Meiyo Peng's message of "Sat, 27 Jan
 2018 17:11:46 +0800")
References: <87inbnpsx9.fsf@HIDDEN>
Date: Sat, 27 Jan 2018 10:36:42 +0000
Message-ID: <87shar8u6d.fsf@HIDDEN>
MIME-Version: 1.0
Content-Type: text/plain
X-Spam-Score: -0.7 (/)
X-Debbugs-Envelope-To: 30265
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -0.7 (/)

Hi Meiyo,

thanks for your report. Indeed, Fish has some problems in Guix.

On Sat, 27 Jan 2018, Meiyo Peng <meiyo.peng@HIDDEN> wrote:
> Hi,
>
> I am using GuixSD 0.14. After upgrading fish shell to latest version(v2.7.1) and
> running `guix gc`, fish shell does not work well.

Can you explain a bit more about your setup? I assume you use
fish as you user shell and not just as a shell you switch into
from a Bash enabled user, correct?

> #+BEGIN_EXAMPLE
>   meiyo@guix ~$ fish
>   fish:
>   echo $_ " "; __fish_pwd
>                ^
>   in command substitution
>           called on standard input
>
>   fish:
>   __fish_pwd
>   ^
>   in command substitution
>           called on standard input
>
>   in command substitution
>           called on standard input
>
>   fish:
>   echo $_ " "; __fish_pwd
>                ^
>   in command substitution
>           called on standard input
> #+END_EXAMPLE
>
>
> __fish_pwd is a fish function. It's defined in
> `share/fish/functions/__fish_pwd.fish`.  The error message shows that fish
> cannot load __fish_pwd's function definition from disk. After doing some
> research, I found out that the error was caused by wrong environment variables.
>
> Fish shell is installed in:
>
> #+BEGIN_EXAMPLE
>   /gnu/store/ajbbi9cgj9j0my7v5habp0lcysaf2a51-fish-2.7.1/
> #+END_EXAMPLE
>
>
> But the environment variable $fish_function_path does not exist. And these
> environment variables point to non-existent paths:
>
> #+BEGIN_EXAMPLE
>   __fish_bin_dir /gnu/store/4jkxcz8kpy621ycmqn3rvs0fv6c98h6p-fish-2.7.1/bin
>   __fish_datadir /gnu/store/4jkxcz8kpy621ycmqn3rvs0fv6c98h6p-fish-2.7.1/share/fish
> #+END_EXAMPLE
>
>
> Setting $fish_function_path to the correct path reduces the error message.
>
> #+BEGIN_EXAMPLE
>   set fish_function_path /gnu/store/ajbbi9cgj9j0my7v5habp0lcysaf2a51-fish-2.7.1/share/fish/functions
> #+END_EXAMPLE
>
>
> `share/fish/config.fish` states $__fish_datadir is set by fish.cpp,
> and $fish_function_path is derived from $__fish_datadir.
>
> #+BEGIN_SRC fish
>   # __fish_datadir, __fish_sysconfdir, __fish_help_dir, __fish_bin_dir
>   # are expected to have been set up by read_init from fish.cpp
>
>
>   # Set up function and completion paths. Make sure that the fish
>   # default functions/completions are included in the respective path.
>
>   if not set -q fish_function_path
>       set fish_function_path $configdir/fish/functions $__fish_sysconfdir/functions $__extra_functionsdir $__fish_datadir/functions
>   end
>
>   if not contains -- $__fish_datadir/functions $fish_function_path
>       set fish_function_path $fish_function_path $__fish_datadir/functions
>   end
> #+END_SRC
>
> In conclusion, I think some path related variables are not set correctly when
> fish is compiled from source code and that caused the bug I met. But since I'm
> not good at C++ programming, I will not dive deeper.
>
> I hope that the information provided above is helpful.
>
>
> Meiyo Peng

It's more or less known, I assume this is related to bug#27206

https://debbugs.gnu.org/cgi/bugreport.cgi?bug=27206

Which to my knowledge and sources I've read doesn't require C
knowledge but more knowledge of how Fish interacts on
system/vendor level and some testing with the resources I've
provided in the other thread/bug.
-- 
ng0 :: https://ea.n0.is
A88C8ADD129828D7EAC02E52E22F9BBFEE348588 :: https://ea.n0.is/keys/




Information forwarded to bug-guix@HIDDEN:
bug#30265; Package guix. Full text available.

Message received at submit <at> debbugs.gnu.org:


Received: (at submit) by debbugs.gnu.org; 27 Jan 2018 09:12:23 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Sat Jan 27 04:12:23 2018
Received: from localhost ([127.0.0.1]:44332 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1efMX9-0000Fs-5z
	for submit <at> debbugs.gnu.org; Sat, 27 Jan 2018 04:12:23 -0500
Received: from eggs.gnu.org ([208.118.235.92]:47726)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <meiyo.peng@HIDDEN>) id 1efMX7-0000Fg-UW
 for submit <at> debbugs.gnu.org; Sat, 27 Jan 2018 04:12:22 -0500
Received: from Debian-exim by eggs.gnu.org with spam-scanned (Exim 4.71)
 (envelope-from <meiyo.peng@HIDDEN>) id 1efMX1-0000oI-Pi
 for submit <at> debbugs.gnu.org; Sat, 27 Jan 2018 04:12:16 -0500
X-Spam-Checker-Version: SpamAssassin 3.3.2 (2011-06-06) on eggs.gnu.org
X-Spam-Level: 
X-Spam-Status: No, score=0.0 required=5.0 tests=BAYES_40,FREEMAIL_FROM,
 T_DKIM_INVALID autolearn=disabled version=3.3.2
Received: from lists.gnu.org ([2001:4830:134:3::11]:33781)
 by eggs.gnu.org with esmtps (TLS1.0:RSA_AES_256_CBC_SHA1:32)
 (Exim 4.71) (envelope-from <meiyo.peng@HIDDEN>)
 id 1efMX1-0000oC-My
 for submit <at> debbugs.gnu.org; Sat, 27 Jan 2018 04:12:15 -0500
Received: from eggs.gnu.org ([2001:4830:134:3::10]:38692)
 by lists.gnu.org with esmtp (Exim 4.71)
 (envelope-from <meiyo.peng@HIDDEN>) id 1efMX0-0000bz-GC
 for bug-guix@HIDDEN; Sat, 27 Jan 2018 04:12:15 -0500
Received: from Debian-exim by eggs.gnu.org with spam-scanned (Exim 4.71)
 (envelope-from <meiyo.peng@HIDDEN>) id 1efMWx-0000kr-9X
 for bug-guix@HIDDEN; Sat, 27 Jan 2018 04:12:14 -0500
Received: from mail-pg0-x243.google.com ([2607:f8b0:400e:c05::243]:43808)
 by eggs.gnu.org with esmtps (TLS1.0:RSA_AES_128_CBC_SHA1:16)
 (Exim 4.71) (envelope-from <meiyo.peng@HIDDEN>)
 id 1efMWx-0000iq-3Q
 for bug-guix@HIDDEN; Sat, 27 Jan 2018 04:12:11 -0500
Received: by mail-pg0-x243.google.com with SMTP id n17so1571398pgf.10
 for <bug-guix@HIDDEN>; Sat, 27 Jan 2018 01:12:10 -0800 (PST)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=gmail.com; s=20161025;
 h=from:to:subject:date:message-id:mime-version;
 bh=Io8WIf1y3pT48sAwCerBiSNqH9XXRZiUNdaT9/nYGFc=;
 b=k0AEvta9eXuNEdYaLNNzas7pTtVdsMbtp3RFW91MXdqQn4Rx2VjJXmAG8VuC/yhVtk
 jALwnqPqkfRVtaluO65tj6+PgS/ZjrcSeaMkCbHDxDhuWyPSwvCoeUorQN1XPoHAKpu/
 xfzbvYEF2fnm82POqtZ3GuLj7Yp5Ii1CI66gQFUruFOqdFdYNEfZOex+wfDmDIsg5dtt
 9txBc3d9NVtJSF1GUUyDZpsU9qNofldvdyT9emYOFRuuFOLRE6ffoJRtiIjd266Ve7Ke
 KVSIwB9eeXdBQUwdXyg6j4fwdXyZPs+x+d2seG2krYUB8FG67RJeUknXsB0BqxeJYqaC
 1PiA==
X-Google-DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed;
 d=1e100.net; s=20161025;
 h=x-gm-message-state:from:to:subject:date:message-id:mime-version;
 bh=Io8WIf1y3pT48sAwCerBiSNqH9XXRZiUNdaT9/nYGFc=;
 b=lv38P0CW8ev22pL9FF5vJuGFYh+/7I/Vgb20g4FKUWYasb4+d68WSR42UNd+3cc8Zb
 3RYtJhb3h/X0V4yckYIunlw5jtP/Aa42+H/2DE0Rvc/xJO1B7q1WYakRoqiOx12lSWGS
 a7gRgP6IcFzBUIsY6Z0wTg57W8CXWI9kUF3EvPjTKODdasXoNOBKVEfbIvdMdMp64qaU
 lOYBlCFLORcz9+USTq5MY68ZJUyeTS0sECauem0E4SNKLynpF79yn2qAlfZoC6fSHDkv
 FKqpr+rpjcon4g7lC+o7gOv+SzgBMjZ09654hTQiNOGDq0hRL6Fg7XdQW3bbOXFSWbkk
 t0HA==
X-Gm-Message-State: AKwxytdNdYAc7T1+KTfxDC3Tg2BZlxelM7/sfWbksUhSq656LKOXlfBA
 5kWzDA0FEHsEH5zKRu3k2n9VSZfq
X-Google-Smtp-Source: AH8x227NevVdbXE+s7AIB2Kiy0RLI0JxV6kWueckpM5bZVaavXS6xHGoG/xjvZBXVF689riVEFnhaQ==
X-Received: by 10.99.9.1 with SMTP id 1mr10930833pgj.257.1517044329056;
 Sat, 27 Jan 2018 01:12:09 -0800 (PST)
Received: from sid ([27.17.20.242])
 by smtp.gmail.com with ESMTPSA id g69sm11367846pgc.32.2018.01.27.01.12.05
 for <bug-guix@HIDDEN>
 (version=TLS1_2 cipher=ECDHE-RSA-CHACHA20-POLY1305 bits=256/256);
 Sat, 27 Jan 2018 01:12:07 -0800 (PST)
From: Meiyo Peng <meiyo.peng@HIDDEN>
To: bug-guix@HIDDEN
Subject: Fish shell has wrong path variables
Date: Sat, 27 Jan 2018 17:11:46 +0800
Message-ID: <87inbnpsx9.fsf@HIDDEN>
MIME-Version: 1.0
Content-Type: text/plain
X-detected-operating-system: by eggs.gnu.org: Genre and OS details not
 recognized.
X-detected-operating-system: by eggs.gnu.org: GNU/Linux 2.6.x
X-Received-From: 2001:4830:134:3::11
X-Spam-Score: -4.0 (----)
X-Debbugs-Envelope-To: submit
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -4.0 (----)

Hi,

I am using GuixSD 0.14. After upgrading fish shell to latest version(v2.7.1) and
running `guix gc`, fish shell does not work well.
#+BEGIN_EXAMPLE
  meiyo@guix ~$ fish
  fish:
  echo $_ " "; __fish_pwd
               ^
  in command substitution
          called on standard input

  fish:
  __fish_pwd
  ^
  in command substitution
          called on standard input

  in command substitution
          called on standard input

  fish:
  echo $_ " "; __fish_pwd
               ^
  in command substitution
          called on standard input
#+END_EXAMPLE

__fish_pwd is a fish function. It's defined in
`share/fish/functions/__fish_pwd.fish`.  The error message shows that fish
cannot load __fish_pwd's function definition from disk. After doing some
research, I found out that the error was caused by wrong environment variables.

Fish shell is installed in:
#+BEGIN_EXAMPLE
  /gnu/store/ajbbi9cgj9j0my7v5habp0lcysaf2a51-fish-2.7.1/
#+END_EXAMPLE

But the environment variable $fish_function_path does not exist. And these
environment variables point to non-existent paths:
#+BEGIN_EXAMPLE
  __fish_bin_dir /gnu/store/4jkxcz8kpy621ycmqn3rvs0fv6c98h6p-fish-2.7.1/bin
  __fish_datadir /gnu/store/4jkxcz8kpy621ycmqn3rvs0fv6c98h6p-fish-2.7.1/share/fish
#+END_EXAMPLE

Setting $fish_function_path to the correct path reduces the error message.
#+BEGIN_EXAMPLE
  set fish_function_path /gnu/store/ajbbi9cgj9j0my7v5habp0lcysaf2a51-fish-2.7.1/share/fish/functions
#+END_EXAMPLE

`share/fish/config.fish` states $__fish_datadir is set by fish.cpp,
and $fish_function_path is derived from $__fish_datadir.
#+BEGIN_SRC fish
  # __fish_datadir, __fish_sysconfdir, __fish_help_dir, __fish_bin_dir
  # are expected to have been set up by read_init from fish.cpp


  # Set up function and completion paths. Make sure that the fish
  # default functions/completions are included in the respective path.

  if not set -q fish_function_path
      set fish_function_path $configdir/fish/functions $__fish_sysconfdir/functions $__extra_functionsdir $__fish_datadir/functions
  end

  if not contains -- $__fish_datadir/functions $fish_function_path
      set fish_function_path $fish_function_path $__fish_datadir/functions
  end
#+END_SRC

In conclusion, I think some path related variables are not set correctly when
fish is compiled from source code and that caused the bug I met. But since I'm
not good at C++ programming, I will not dive deeper.

I hope that the information provided above is helpful.


Meiyo Peng




Acknowledgement sent to Meiyo Peng <meiyo.peng@HIDDEN>:
New bug report received and forwarded. Copy sent to bug-guix@HIDDEN. Full text available.
Report forwarded to bug-guix@HIDDEN:
bug#30265; Package guix. Full text available.
Please note: This is a static page, with minimal formatting, updated once a day.
Click here to see this page with the latest information and nicer formatting.
Last modified: Wed, 26 Dec 2018 16:15:01 UTC

GNU bug tracking system
Copyright (C) 1999 Darren O. Benham, 1997 nCipher Corporation Ltd, 1994-97 Ian Jackson.